var w = Object.defineProperty;
var v = (t, e, n) => e in t ? w(t, e, { enumerable: !0, configurable: !0, writable: !0, value: n }) : t[e] = n;
var a = (t, e, n) => v(t, typeof e != "symbol" ? e + "" : e, n);
var A = /* @__PURE__ */ ((t) => (t.PRIVATE = "WALLET", t.VASP = "VASP", t))(A || {}), g = /* @__PURE__ */ ((t) => (t.NATURAL = "natural", t.LEGAL = "legal", t.SELF = "self", t))(g || {}), y = /* @__PURE__ */ ((t) => (t.EMPTY = "empty", t.VERIFY = "verify", t.PENDING = "pending", t.VERIFIED = "verified", t.BANNED = "banned", t))(y || {}), I = /* @__PURE__ */ ((t) => (t.ALLOWED = "allowed", t.PENDING = "pending", t))(I || {}), C = /* @__PURE__ */ ((t) => (t.ASSET = "asset", t.DESTINATION = "destination", t.COUNTERPARTY = "counterparty", t.AGENT = "agent", t))(C || {}), l = /* @__PURE__ */ ((t) => (t.COMPLETE = "complete", t.RESIZE = "resize", t.RESULT = "result", t.READY = "ready", t.INVALID = "invalid", t.ERROR = "error", t.CANCEL = "cancel", t))(l || {}), L = /* @__PURE__ */ ((t) => (t.SERVICE_UNAVAILABLE = "SERVICE_UNAVAILABLE", t.WALLET_CONNECTION_FAILED = "WALLET_CONNECTION_FAILED", t.WALLET_NOT_SUPPORTED = "WALLET_NOT_SUPPORTED", t.TOKEN_INVALID = "TOKEN_INVALID", t))(L || {}), u = /* @__PURE__ */ ((t) => (t.UPDATE = "update", t.REQUEST_RESPONSE = "requestResponse", t))(u || {}), b = /* @__PURE__ */ ((t) => (t.PENDING = "pending", t.FAILED = "rejected", t.FLAGGED = "flagged", t.VERIFIED = "verified", t))(b || {}), N = /* @__PURE__ */ ((t) => (t.SelfDeclaration = "self-declaration", t.SIWE = "siwe", t.SIWX = "siwx", t.EIP191 = "eip-191", t.EIP712 = "eip-712", t.EIP1271 = "eip-1271", t.BIP137 = "bip-137", t.BIP322 = "bip-322", t.BIP137_XPUB = "xpub", t.TIP191 = "tip-191", t.ED25519 = "ed25519", t.XRP_ED25519 = "xrp-ed25519", t.CIP8 = "cip-8", t.MicroTransfer = "microtransfer", t.Screenshot = "screenshot", t.Connect = "connect", t))(N || {});
class U {
  constructor() {
    a(this, "listeners", /* @__PURE__ */ new Map());
    a(this, "port");
    this.handleMessage = this.handleMessage.bind(this);
  }
  /**
   * Sets up the message port for communication.
   *
   * Initializes the MessagePort for receiving messages by setting up the message handler
   * and starting the port.
   *
   * @param port - The MessagePort instance to use for communication
   */
  setPort(e) {
    this.port = e, this.port.onmessage = this.handleMessage, this.port.start();
  }
  /**
     * Registers a callback for a specific message type.
     *
     * When messages of the specified type are received, the callback will be executed
     * with the message data.
     *
     * @param messageType - The type of message to listen for
     * @param callback - The callback function to execute when matching messages are received
  
     */
  on(e, n) {
    return this.listeners.has(e) || this.listeners.set(e, /* @__PURE__ */ new Set()), this.listeners.get(e).add(n), () => this.off(e, n);
  }
  /**
   * Removes a callback for a specific message type.
   *
   * If the callback is the last one registered for the message type,
   * the message type entry will be removed entirely.
   *
   * @param messageType - The type of message to remove listener from
   * @param callback - The callback function to remove
   */
  off(e, n) {
    const r = this.listeners.get(e);
    r && (r.delete(n), r.size === 0 && this.listeners.delete(e));
  }
  /**
   * Internal message handler for processing received messages.
   *
   * Validates incoming messages and dispatches them to registered callbacks
   * based on the message type.
   *
   * @param event - The message event containing the component message
   */
  handleMessage(e) {
    const n = e.data;
    if (typeof n == "object" && n !== null && "type" in n) {
      const r = n.type, i = this.listeners.get(r);
      i && i.forEach((s) => s(n));
    }
  }
  /**
   * Sends a message through the message port
   * @param message The host message to send
   */
  send(e) {
    this.port && this.port.postMessage(e);
  }
}
class _ {
  /**
   * Creates an instance of EmbeddedComponent.
   * @param url - The URL of the embedded component
   * @param value - The initial transaction value
   */
  constructor(e, n, r) {
    a(this, "_url");
    a(this, "_value");
    a(this, "_options");
    a(this, "_errors", []);
    a(this, "iframe");
    a(this, "eventManager");
    a(this, "modal");
    this._url = e, this._value = n, this._options = r, this.eventManager = new U(), this.on(l.INVALID, (i) => {
      i.type === l.INVALID && (this._errors = i.errors, this._value = i.value);
    }), this.on(l.RESIZE, (i) => {
      i.type === l.RESIZE && this.iframe && (this.iframe.style.height = `${i.height}px`);
    });
  }
  /**
   * Gets the URL of the embedded component
   * @returns The URL of the embedded component
   */
  get url() {
    return this._url;
  }
  /**
   * Gets the current transaction value
   * @returns The current transaction value
   */
  get value() {
    return this._value;
  }
  get options() {
    return this._options;
  }
  get errors() {
    return this._errors;
  }
  /**
   * Opens the component URL in the current window
   */
  open() {
    document.location.href = this.url;
  }
  /**
   * Mounts the component to a parent element
   * @param parentId - The ID of the parent element
   * @throws Will throw an error if the parent element is not found
   */
  mount(e) {
    const n = document.querySelector(e);
    if (!n) throw new Error(`parentID ${e} not found`);
    this.embed(n);
  }
  /**
   * Embeds the component into a parent element
   * @param parent - The parent element to embed the component into
   */
  embed(e, n = !1) {
    var r, i;
    this.removeEmbed(), this.iframe = document.createElement("iframe"), this.iframe.src = this.url + (n ? "" : "&embedded=true"), this.iframe.allow = "web-share; clipboard-write; hid; bluetooth;", this.iframe.style.width = "100%", this.iframe.style.height = "0px", this.iframe.style.border = "none", this.iframe.style.overflow = "hidden", this.iframe.scrolling = "no", e.appendChild(this.iframe), window.addEventListener("message", (s) => {
      var o, c;
      s.source === ((o = this.iframe) == null ? void 0 : o.contentWindow) && ((c = this.eventManager) == null || c.setPort(s.ports[0]));
    }), (i = (r = this.iframe) == null ? void 0 : r.contentWindow) == null || i.focus();
  }
  removeEmbed() {
    this.iframe && this.iframe.remove();
  }
  /**
   * Sends a message to the embedded component
   * @param message - The message to send
   */
  send(e) {
    this.eventManager.send(e);
  }
  /**
   * Adds an event listener for a specific message type
   * @param messageType - The type of message to listen for
   * @param callback - The callback function to execute when the message is received
   */
  on(e, n) {
    return this.eventManager.on(e, n);
  }
  /**
   * Removes an event listener for a specific message type
   * @param messageType - The type of message to stop listening for
   * @param callback - The callback function to remove
   */
  off(e, n) {
    this.eventManager.off(e, n);
  }
  /**
   * Updates the transaction value and sends an update message to the component
   * @param value - The new transaction value
   */
  update(e, n) {
    this._value = e, n && (this._options = n), this.send({ type: u.UPDATE, value: e, options: this._options });
  }
  /**
   * Waits for the component to complete and returns the transaction response
   * @returns A promise that resolves with the transaction response
   */
  completion() {
    return new Promise((e, n) => {
      let r, i, s;
      function o() {
        r && r(), i && i(), s && s();
      }
      r = this.on(l.COMPLETE, (c) => {
        e(c.response), o();
      }), i = this.on(l.CANCEL, () => {
        n(new Error("User cancelled")), o();
      }), s = this.on("error", (c) => {
        n(new Error(c.message)), o();
      });
    });
  }
  /**
   * Opens the component in a modal dialog
   */
  async openModal() {
    this.modal && this.closeModal(), this.modal = document.createElement("dialog"), this.modal.style.border = "none", this.modal.style.backgroundColor = "white", this.modal.style.maxWidth = "100vw", this.modal.style.maxHeight = "100vh", this.modal.style.width = "600px", this.modal.style.height = "600px", document.body.appendChild(this.modal), this.embed(this.modal, !0);
    const e = this.on(l.CANCEL, () => {
      this.closeModal();
    }), n = this.on(l.COMPLETE, () => {
      this.closeModal();
    });
    return this.modal.showModal(), this.modal.addEventListener("click", () => {
      this.closeModal();
    }), this.completion().finally(() => {
      e(), n();
    });
  }
  /**
   * Closes the modal dialog
   *
   */
  closeModal() {
    var e;
    this.modal && ((e = this.modal) == null || e.close(), this.modal.remove(), this.modal = void 0);
  }
  /**
   * Opens the component in a popup window. This may be needed to support many self-hosted wallets
   * @returns A promise that resolves with the transaction response
   * @see [MDN](https://developer.mozilla.org/en-US/docs/Web/API/Window/open#restrictions)
   * @see [Cross-Origin-Opener-Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Cross-Origin-Opener-Policy)
   */
  async popup() {
    const e = window.open(
      this.url,
      "_blank",
      "popup=true,width=600,height=600"
    );
    window.addEventListener("message", (i) => {
      var s;
      i.source === e && (console.log("received message from popup", i.data), (s = this.eventManager) == null || s.setPort(i.ports[0]));
    });
    const n = this.on(l.CANCEL, () => {
      e == null || e.close();
    }), r = this.on(l.COMPLETE, () => {
      e == null || e.close();
    });
    return this.completion().finally(() => {
      n(), r();
    });
  }
}
function R(t) {
  return Object.entries(t).map(([e, n]) => {
    if (n == null) return;
    const r = encodeURIComponent(e), i = encodeURIComponent(
      typeof n == "object" ? JSON.stringify(n) : String(n)
      // Use String() to handle all primitive types
    );
    return `${r}=${i}`;
  }).filter((e) => e !== void 0).join("&");
}
function O(t) {
  const e = t.slice(1);
  return e ? e.split("&").filter(Boolean).reduce(
    (r, i) => {
      const [s, o] = i.split("=");
      return s && (r[decodeURIComponent(s)] = o ? decodeURIComponent(o) : ""), r;
    },
    {}
  ) : {};
}
async function d(t) {
  const e = JSON.stringify(t), n = new TextEncoder(), r = crypto.getRandomValues(new Uint8Array(32)), i = await crypto.subtle.importKey(
    "raw",
    r,
    { name: "AES-GCM" },
    !1,
    ["encrypt"]
  ), s = crypto.getRandomValues(new Uint8Array(12)), o = await crypto.subtle.encrypt(
    { name: "AES-GCM", iv: s },
    i,
    n.encode(e)
  );
  return {
    ciphertext: `${h(s)}-${h(o)}`,
    key: h(r)
  };
}
async function x({ ciphertext: t, key: e }) {
  const [n, r] = t.split("-"), i = new Uint8Array(
    atob(e).split("").map((f) => f.charCodeAt(0))
  ), s = m(n), o = m(r), c = await crypto.subtle.importKey(
    "raw",
    i,
    { name: "AES-GCM" },
    !1,
    ["decrypt"]
  ), p = new TextDecoder(), E = await crypto.subtle.decrypt(
    { name: "AES-GCM", iv: new Uint8Array(s) },
    c,
    o
  );
  return JSON.parse(p.decode(E));
}
function h(t) {
  const e = new Uint8Array(t);
  let n = "";
  for (let r = 0; r < e.length; r++)
    n += String.fromCharCode(e[r]);
  return btoa(n);
}
function m(t) {
  const e = atob(t), n = new Uint8Array(e.length);
  for (let r = 0; r < e.length; r++)
    n[r] = e.charCodeAt(r);
  return n;
}
class M {
  constructor(e) {
    a(this, "endpoint");
    this.endpoint = e;
  }
  /**
   * Creates a new encrypted connection
   * @param data The component request data to encrypt and store
   * @param participants Array of participant identifiers
   * @returns Promise resolving to connection details including ID, version, and encryption key
   */
  async create(e, n) {
    const r = await d(e), i = {
      metadata: n,
      sealed: r.ciphertext
    }, s = await fetch(this.endpoint, {
      method: "POST",
      headers: {
        "Content-Type": "application/json"
      },
      body: JSON.stringify(i)
    });
    if (!s.ok)
      throw new Error(`Failed to create connection: ${await s.text()}`);
    const o = await s.json();
    return {
      id: o.id,
      version: o.version,
      metadata: n,
      data: e,
      key: r.key
    };
  }
  /**
   * Updates an existing connection with new encrypted data
   * @param id Connection ID
   * @param data New data to encrypt and store
   * @param version Current version number
   * @returns Promise resolving to updated connection details including new encryption key
   */
  async update(e, n, r) {
    const i = await d(n), s = {
      sealed: i.ciphertext,
      version: r
    }, o = await fetch(`${this.endpoint}/${e}`, {
      method: "PATCH",
      headers: {
        "Content-Type": "application/json"
      },
      body: JSON.stringify(s)
    });
    if (!o.ok)
      throw new Error(`Failed to update connection: ${await o.text()}`);
    const c = await o.json();
    return {
      id: c.id,
      metadata: c.metadata,
      version: c.version,
      data: n,
      key: i.key
    };
  }
  /**
   * Retrieves and decrypts connection data
   * @param id Connection ID
   * @param key Encryption key from previous create/update operation
   * @returns Promise resolving to connection details including decrypted data
   */
  async get(e, n) {
    const r = await fetch(`${this.endpoint}/${e}`, {
      method: "GET"
    });
    if (!r.ok)
      throw new Error(`Failed to get connection: ${await r.text()}`);
    const i = await r.json(), s = i.sealed[i.sealed.length - 1], o = await x({
      ciphertext: s,
      key: n
    });
    return {
      id: i.id,
      version: i.version,
      metadata: i.metadata,
      data: o,
      key: n
    };
  }
  /**
   * Closes a connection
   * @param id Connection ID
   */
  async close(e) {
    const n = await fetch(`${this.endpoint}/${e}`, {
      method: "DELETE"
    });
    if (!n.ok)
      throw new Error(`Failed to close connection: ${await n.text()}`);
  }
}
class S {
  /**
   * Creates a new instance of the Notabene SDK
   *
   * @param config - Configuration options for the Notabene SDK
   */
  constructor(e) {
    a(this, "nodeUrl");
    a(this, "authToken");
    a(this, "uxUrl");
    a(this, "theme");
    a(this, "locale");
    this.uxUrl = e.uxUrl || "https://connect.notabene.id", this.nodeUrl = e.nodeUrl, this.authToken = e.authToken, this.theme = e.theme, this.locale = e.locale;
  }
  /**
   * Generates a URL for a Notabene component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param configuration - Optional transaction configuration
   * @param callbacks - Optional callback configuration
   * @returns component URL
   * @internal
   */
  componentUrl(e, n, r, i) {
    const s = new URL(this.uxUrl);
    s.pathname = e;
    const o = R({
      authToken: this.authToken,
      value: n,
      configuration: r
    });
    return s.hash = o, this.nodeUrl && s.searchParams.set("nodeUrl", this.nodeUrl), this.theme && s.searchParams.set("theme", JSON.stringify(this.theme)), this.locale && s.searchParams.set("locale", this.locale), i && (i.callback && s.searchParams.set("callback_url", i.callback), i.redirectUri && s.searchParams.set("redirect_uri", i.redirectUri)), s.toString();
  }
  /**
   * Creates a new embedded component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance
   * @internal
   */
  createComponent(e, n, r, i) {
    return new _(
      this.componentUrl(e, n, r, i),
      n,
      r
    );
  }
  /**
   * Creates a withdrawal assist component
   *
   * @param value - Withdrawal transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for withdrawal assistance
   */
  createWithdrawalAssist(e, n, r) {
    return this.createComponent(
      "withdrawal-assist",
      e,
      n,
      r
    );
  }
  /**
   * Creates a connect component
   *
   * @param value - Connection request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for connection
   * @alpha
   */
  createConnectWallet(e, n, r) {
    return this.createComponent(
      "connect",
      e,
      n,
      r
    );
  }
  /**
   * Creates a deposit request component
   *
   * @param value - Deposit request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit requests
   * @public
   */
  createDepositRequest(e, n, r) {
    return this.createComponent(
      "deposit-request",
      e,
      n,
      r
    );
  }
  /**
   * Creates a deposit assist component
   *
   * @param value - Partial deposit transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit assistance
   * @public
   */
  createDepositAssist(e, n, r) {
    return this.createComponent(
      "deposit-assist",
      e,
      n,
      r
    );
  }
}
export {
  A as AgentType,
  l as CMType,
  M as ConnectionManager,
  _ as EmbeddedComponent,
  L as ErrorIdentifierCode,
  u as HMType,
  g as PersonType,
  b as ProofStatus,
  N as ProofTypes,
  y as Status,
  I as VASPSearchControl,
  C as ValidationSections,
  O as decodeFragmentToObject,
  S as default
};
