[**@notabene/javascript-sdk**](../../README.md)

***

[@notabene/javascript-sdk](../../modules.md) / [types](../README.md) / ComponentResponse

# Interface: ComponentResponse

Base response interface for all SDK component operations

## Remarks

Provides standardized response propertiesfor component interactions:
- requestID: Links response back to the originating request
- valid: Boolean indicating if the operation was valid/successful
- status: Current verification status of the operation
- errors: Array of validation errors if any occurred

This interface is extended by specific response types like:
- TransResponse for transaction operations
- ConnectionResponse for VASP connection operations

## See

 - [Status](../enumerations/Status.md) For possible status values
 - [ValidationError](../type-aliases/ValidationError.md) For error structure
 - [TransactionResponse](TransactionResponse.md) For transaction-specific responses

## Extended by

- [`TransactionResponse`](TransactionResponse.md)

## Properties

### errors

> **errors**: [`ValidationError`](../type-aliases/ValidationError.md)[]

#### Defined in

[types.ts:671](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L671)

***

### requestID

> **requestID**: `string`

#### Defined in

[types.ts:668](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L668)

***

### status

> **status**: [`Status`](../enumerations/Status.md)

#### Defined in

[types.ts:670](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L670)

***

### valid

> **valid**: `boolean`

#### Defined in

[types.ts:669](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L669)
