[**@notabene/javascript-sdk**](../../README.md)

***

[@notabene/javascript-sdk](../../modules.md) / [types](../README.md) / TransactionResponse

# Interface: TransactionResponse\<V\>

Response interface for transaction-related operations

## Remarks

Extends ComponentResponse to add transaction-specific response data:
- value: The resulting transaction value of generic type V
- ivms101: IVMS 101 travel rule data for the transaction
- proof: Optional ownership proof details if required
- txCreate: Optional V1 transaction payload for legacy API compatibility
- txUpdate: Optional V1 transaction payload for legacy API compatibility

## See

 - [ComponentResponse](ComponentResponse.md) For base response properties
 - [IVMS101](../../ivms/types/type-aliases/IVMS101.md) For travel rule data structure
 - [OwnershipProof](OwnershipProof.md) For proof details
 - [V1Transaction](../type-aliases/V1Transaction.md) For legacy transaction format

## Extends

- [`ComponentResponse`](ComponentResponse.md)

## Type Parameters

• **V**

Type of the transaction value being returned

## Properties

### errors

> **errors**: [`ValidationError`](../type-aliases/ValidationError.md)[]

#### Inherited from

[`ComponentResponse`](ComponentResponse.md).[`errors`](ComponentResponse.md#errors)

#### Defined in

[types.ts:671](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L671)

***

### ivms101

> **ivms101**: [`IVMS101`](../../ivms/types/type-aliases/IVMS101.md)

#### Defined in

[types.ts:695](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L695)

***

### proof?

> `optional` **proof**: [`OwnershipProof`](OwnershipProof.md)

#### Defined in

[types.ts:696](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L696)

***

### requestID

> **requestID**: `string`

#### Inherited from

[`ComponentResponse`](ComponentResponse.md).[`requestID`](ComponentResponse.md#requestid)

#### Defined in

[types.ts:668](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L668)

***

### status

> **status**: [`Status`](../enumerations/Status.md)

#### Inherited from

[`ComponentResponse`](ComponentResponse.md).[`status`](ComponentResponse.md#status)

#### Defined in

[types.ts:670](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L670)

***

### txCreate?

> `optional` **txCreate**: [`V1Transaction`](../type-aliases/V1Transaction.md)

#### Defined in

[types.ts:697](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L697)

***

### txUpdate?

> `optional` **txUpdate**: [`V1Transaction`](../type-aliases/V1Transaction.md)

#### Defined in

[types.ts:698](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L698)

***

### valid

> **valid**: `boolean`

#### Inherited from

[`ComponentResponse`](ComponentResponse.md).[`valid`](ComponentResponse.md#valid)

#### Defined in

[types.ts:669](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L669)

***

### value

> **value**: `V`

#### Defined in

[types.ts:694](https://gitlab.com/notabene/open-source/javascript-sdk/-/blob/80aada173fac6a9b5f05869abafa3c1c6cc56aa9/src/types.ts#L694)
